		/*----------------------------------------------------
		 *由服务端WGT包热更新本APP
		 *@param methodName String 接口方法名
		 *@param data       Array  接口数据数组（格式：[{id=字段名,value=值,type=类型},{第二个数据}]）
		 *@desc 
		 * 1.下载wgt包
		 * 2.更新内容，包括mainifest.json
		 *-------------------------------------------------------
		 */
		 
		var wgtWaiting = null;
		
		/**
		 * 
		 */
        function downWgt(targetUrl) {
                wgtWaiting = plus.nativeUI.showWaiting("开始下载");
                var wgtUrl = targetUrl;
                var wgtOption = { filename: "_doc/update/", retry: 1 };
                var task = 
                plus.downloader.createDownload(wgtUrl, wgtOption, function (download, status) {
                    if (status == 200) {
                        wgtWaiting.setTitle("开始安装");
                        installWgt(download.filename);
                    } else {
                        mui.alert("应用升级失败！");
                        wgtWaiting.close();
                    }
                });

                task.addEventListener("statechanged", function (download, status) {
                    switch (download.state) {
                        case 2:
                            wgtWaiting.setTitle("已连接到服务器");
                            break;
                        case 3:
                            var percent = download.downloadedSize / download.totalSize * 100;
                            wgtWaiting.setTitle("已下载 " + parseInt(percent) + "%");
                            break;
                        case 4:
                            wgtWaiting.setTitle("下载完成");
                            break;
                    }
                });
                task.start();
            };

            function installWgt(wgtpath) {
                plus.runtime.install(wgtpath, {}, function (wgtinfo) {
                    wgtWaiting.close();
                    mui.alert("更新完成，须重启应用！", function () {
                        plus.runtime.restart();
                    });
                }, function (error) {
                    wgtWaiting.close();
                    mui.alert("应用更新失败！\n" + error.message);
                });
            };