/**
 * WYYOSP平台接口及资源地址配置
 * WYYAPI接口客户端助手类
 */
		////UAT Environment params
        //var API_SERVER_URL = 'http://test.wyyapi.enetcity.net/';
        //var API_APP_ID     = 'wyy_ios_app_01';
        //var API_CERT_ID    = '0ca175b9c0f726a831d895e269332461'; 
		//var API_TOKEN      = '123456';                           
		//var APP_IMG_URL	   = 'http://test.wyyosp.enetcity.net/Public/';      // 图片资源地址 
 
        //PRD Environment params
        var API_SERVER_URL = 'http://wyyapi.enetcity.net/';
		var API_DEBUG_STR  = '';
		var API_APP_ID     = 'wyy_app_android_01';                       //wyy_app_ios_01                  
		var API_CERT_ID    = 'e40440a23b4262bba8ce7f0ff06574fa';         //d3f33f923b4262bba8ce7f0ff06574fa
		var API_TOKEN      = 'wyy_20180410';                             //
		var APP_IMG_URL	 = 'http://images.weiyouyou.com/';           // 图片资源地址 
		
		var API_DEBUG_STR  = '';
		var API_DATA	   = null;
		var WAP_URL	       = 'http://m.weiyouyou.com';                 // 网站首页地址
		var APP_ALPAY_URL  = 'http://m.weiyouyou.com/Payment/alipayAppPrePay?';         // 支付宝支付接口地址
		var APP_WXPAY_URL  = 'http://m.weiyouyou.com/Payment/weixinQRCodePayForApp?';   // 微信支付接口地址 

		/**
		 * 提交WYYAPI接口数据到指定服务商URL
		 *@param methodName String 接口方法名
		 *@param data       Array  接口数据数组（格式：[{id=字段名,value=值,type=类型},{第二个数据}]）
		 *@desc 
		 * 只传5个字段：method  sign  app_id  certi_id  data
		 * 规则：
		 * 1.method:按所需接口的已预设方法名，例如 system.time.query
		 * 2.sign: "参数名1=参数值1参数名2=参数值2.. 参数名N=参数值N"MD5+Token后二次MD5，详见下文sign规则
		 * 3.app_id：预先分配的应用ID
		 * 4.certi_id：预先分配的应用授权码
		 * 5.data：按接口参数字段名称=字段值及规定顺序组装的JSON格式字符串
		 */
		 
		function  submitApiInputData(methodName,data,successData){
			//接口调用基本参数：根地址、应用ID、授权码、令牌
			var apiServerUrl = API_SERVER_URL; 			
			var apiAppId     = API_APP_ID;	
			var apiCertiId   = API_CERT_ID;
			var apiToken     = API_TOKEN;
		    var method       = methodName; 
			
			var exField = "method,sign,app_id,certi_id,data"; //例外字段(即不需要处理的字段)
			var preStr = "var_";
			
			if(method==""){
				//接口方法为空，无法提交
				console.log('接口方法为空，无法提交!<br>请点击左侧接口树选择需要调试的接口');
				//想办法弹提示框;
				return false;	
			}
			
			if(apiServerUrl!=''){
				//服务端地址不能为空
				
				//构造API数据data包参数和签名参数
				var dataAry   = buildeDataSignStr(data,exField);
				
				var sign      = buildeApiSignInfo(dataAry[1],apiToken);	
				var app_id    = apiAppId; 
				var certi_id  = apiCertiId; 
				var data      = dataAry[0];//convertJson2Str(dataAry[0]);
				var vdata 	  = null;
				//开始处理API表单数据 ：method  sign  app_id  certi_id  data
				//jiangwenda环境用：apiServerUrl += method.replace("Api/","Api.php/");	 //格式： http://api.server.com/api/xx/xx/xx
				apiServerUrl += method;	 //格式： http://api.server.com/api/xx/xx/xx
				///////showLoadingLayer();//显示loading
				var apiData = {method:method,sign:sign,app_id:app_id,certi_id:certi_id,data:data};	
				postData2Api(apiServerUrl, 
					         apiData, 
							 successData,
							 null);
			}	
			
		}

		/**
			function(data){  //成功回调函数段
								//异步响应信息
								try{
									var obj = eval('(' + data + ')');
									var jsonStr = convertJson2Str(obj); //又把JSON对象转为字符串
									//2017-01-07 增加把HTML代码还原的逻辑，适应有些字段内容是HTML格式内容
									//assets/js/plugins/htmlStrTools/htmlStrTools.js
									var htmlt = new HtmlStrTools(); //工具类在HtmlStrTools.js
									var jsonStr = htmlt.decodeHtml(jsonStr);					
									mui.alert(jsonStr); //显示服务端响应的原样内容
								}
								catch(err){
									//报错了，说明无法转换为JSON对象，则直接输出服务端字符串
									var index = parent.layer.alert('出错了!服务端未能按预期处理数据<br>请把API请求参数、本次响应内容一起发给接口管理员核查', {
										icon: 5,
										shadeClose: true,
										title:'服务端出现异常'
									});				
									mui.alert(data); //显示服务端响应的原样
								}
							},
		 */

		//用于向服务端提交数据并执行回调函数的通用方法
		function postData2Api(url, data, callback, waitingDialog) {  
      		var dataStr = JSON.stringify(data);//JSON.stringify(data);
		    mui.ajax(url,{  
		        data       : data,  
		        dataType   : "json",  
		        type       : "post",  
		        contentType: "application/x-www-form-urlencoded; charset=utf-8",  
		        timeout    :60000,  
		        crossDomain: true, //强制使用5+跨域
		        success    :callback,  
		        error      :function(xhr,type,errorThrown){  
		            if(waitingDialog){waitingDialog.close();}
		            //mui.alert("<网络连接失败，请重新尝试一下>", "错误", "OK", null);  
		            mui.toast('<网络连接失败，请重新尝试一下>',{ duration:'long', type:'div' });
		        }  
		    });  
		} 
		
		
		/*
		 * 根据需要提交的data数组内容生成接口签名字符串
		 * 参数：数据数组[{id=字段名,value=值,type=类型},{第二个数据}]，例外字段
		 * 规则：
		 *  1.按传入的表单，抽取例外字段之外的字段组成JSON字符串
		 *  2.顺带组成"参数名1=参数值1参数名2=参数值2.. 参数名N=参数值N"字符串
		 * 返回数组：0-JSON字符串，1-签名用串
		 */
		function buildeDataSignStr(data,exceptionField){
			//表单序列化
			var f = null; // 
			var jsonObj = {};
			var signStr = "";
			//遍历表单元素，构建JSON字符串及sign内容串
			var itemId="",itemValue="",itemType="",signValue="";
			var isJosn=false;
			for(var idx = 0 ; idx < data.length ; idx++){
				itemId    = data[idx].id;
				itemValue = data[idx].value; 
				itemType  = data[idx].type;
				//if(isJSON(itemValue)==true && itemType.indexOf('JSON') >= 0){
					
					////是JSON字符串，则'取Array(data)'作签名内容
				var oType = checkObjectTypeOf(itemValue);
				// console.log("oType="+oType);
				if(oType=="object" || oType=="array"){
					//对象是object类型，则极有可能是JSON对象，直接按固定字符串处理
					signValue = "Array(data)";
					isJosn=true;
				}
				else{
					//不是JSON字符串
					signValue = itemValue;
					isJosn=false;
				}
				 
				if (exceptionField.indexOf(this.id) < 0 )  {
				  //不是例外字段，则加入json对象中
				  var jsonId = itemId;
				  signStr += jsonId + '=' + signValue;
				  if(isJosn){
					  //是JSON，则把它转为对象后再赋值
					  //jsonObj[jsonId] = JSON.parse(itemValue); 
					  jsonObj[jsonId] = itemValue;
				  }
				  else{
					  //不是，则直接赋值字符串
					  jsonObj[jsonId] = itemValue;
				  }
				} 
			}
			
	
			return new Array(jsonObj,signStr);
			//return signStr;
		}		
		
		//判断字符串是不是JSON格式的字符串
		function isJSON(str) {
		    if (typeof str == 'string') {
		        try {
		            JSON.parse(str);
		            return true;
		        } catch(e) {
	
		            return false;
		        }
		    }
		}
		
		/*
		 * 生成sign字段内容
		 * 规则：
		 *  1.按传入的已拼接"参数名1=参数值1参数名2=参数值2.. 参数名N=参数值N"字符串MD5加密
		 *  2.用步骤1的MD5结果串+Token串再次MD5
		 */
		function buildeApiSignInfo(paramStr,token){
			var rtn  = "";
			var md50 = paramStr;
			var md51 = md5(md50.toUpperCase()); //函数/plugins/md5/jquery.md5.js里
			var md52 = md5(md51.toUpperCase()+token.toUpperCase());
			// console.log(paramStr);
			// console.log(md52.toUpperCase());
			return md52.toUpperCase();
		}		
		
		
		//测试调用WYYAPI
		function testWyyApiMethod(apiMethod,data){
		    submitApiInputData(apiMethod,data);
	    }
		
		
		//判断对象的数据类型
		var oP = Object.prototype,
		toString = oP.toString;
		
		function checkObjectTypeOf(value) {
		    if (null === value) {
		        return 'null';
		    }
		
		    var type = typeof value;
		    if ('undefined' === type || 'string' === type) {
		        return type;
		    }
		
		    var typeString = toString.call(value);
		    switch (typeString) {
		    case '[object Array]':
		        return 'array';
		    case '[object Date]':
		        return 'date';
		    case '[object Boolean]':
		        return 'boolean';
		    case '[object Number]':
		        return 'number';
		    case '[object Function]':
		        return 'function';
		    case '[object RegExp]':
		        return 'regexp';
		    case '[object Object]':
		        if (undefined !== value.nodeType) {
		            if (3 == value.nodeType) {
		                return (/\S/).test(value.nodeValue) ? 'textnode': 'whitespace';
		            } else {
		                return 'element';
		            }
		        } else {
		            return 'object';
		        }
		    default:
		        return 'unknow';
		    }
		}